diff --git a/src/backend/catalog/index.c b/src/backend/catalog/index.c
index 43de42ce39e..7a3ad712975 100644
--- a/src/backend/catalog/index.c
+++ b/src/backend/catalog/index.c
@@ -577,8 +577,8 @@ UpdateIndexRelation(Oid indexoid,
 	int2vector *indoption;
 	Datum		exprsDatum;
 	Datum		predDatum;
-	Datum		values[Natts_pg_index];
-	bool		nulls[Natts_pg_index] = {0};
+	Datum		values[Natts_pg_index] = {0};
+	bool		nulls[Natts_pg_index] = {false};
 	Relation	pg_index;
 	HeapTuple	tuple;
 	int			i;
@@ -632,38 +632,38 @@ UpdateIndexRelation(Oid indexoid,
 	/*
 	 * Build a pg_index tuple
 	 */
-	values[Anum_pg_index_indexrelid - 1] = ObjectIdGetDatum(indexoid);
-	values[Anum_pg_index_indrelid - 1] = ObjectIdGetDatum(heapoid);
-	values[Anum_pg_index_indnatts - 1] = Int16GetDatum(indexInfo->ii_NumIndexAttrs);
-	values[Anum_pg_index_indnkeyatts - 1] = Int16GetDatum(indexInfo->ii_NumIndexKeyAttrs);
-	values[Anum_pg_index_indisunique - 1] = BoolGetDatum(indexInfo->ii_Unique);
-	values[Anum_pg_index_indnullsnotdistinct - 1] = BoolGetDatum(indexInfo->ii_NullsNotDistinct);
-	values[Anum_pg_index_indisprimary - 1] = BoolGetDatum(primary);
-	values[Anum_pg_index_indisexclusion - 1] = BoolGetDatum(isexclusion);
-	values[Anum_pg_index_indimmediate - 1] = BoolGetDatum(immediate);
-	values[Anum_pg_index_indisclustered - 1] = BoolGetDatum(false);
-	values[Anum_pg_index_indisvalid - 1] = BoolGetDatum(isvalid);
-	values[Anum_pg_index_indcheckxmin - 1] = BoolGetDatum(false);
-	values[Anum_pg_index_indisready - 1] = BoolGetDatum(isready);
-	values[Anum_pg_index_indislive - 1] = BoolGetDatum(true);
-	values[Anum_pg_index_indisreplident - 1] = BoolGetDatum(false);
-	values[Anum_pg_index_indkey - 1] = PointerGetDatum(indkey);
-	values[Anum_pg_index_indcollation - 1] = PointerGetDatum(indcollation);
-	values[Anum_pg_index_indclass - 1] = PointerGetDatum(indclass);
-	values[Anum_pg_index_indoption - 1] = PointerGetDatum(indoption);
-	values[Anum_pg_index_indexprs - 1] = exprsDatum;
+	HeapTupleSetValue(pg_index, indexrelid, ObjectIdGetDatum(indexoid), values);
+	HeapTupleSetValue(pg_index, indrelid, ObjectIdGetDatum(heapoid), values);
+	HeapTupleSetValue(pg_index, indnatts, Int16GetDatum(indexInfo->ii_NumIndexAttrs), values);
+	HeapTupleSetValue(pg_index, indnkeyatts, Int16GetDatum(indexInfo->ii_NumIndexKeyAttrs), values);
+	HeapTupleSetValue(pg_index, indisunique, BoolGetDatum(indexInfo->ii_Unique), values);
+	HeapTupleSetValue(pg_index, indnullsnotdistinct, BoolGetDatum(indexInfo->ii_NullsNotDistinct), values);
+	HeapTupleSetValue(pg_index, indisprimary, BoolGetDatum(primary), values);
+	HeapTupleSetValue(pg_index, indisexclusion, BoolGetDatum(isexclusion), values);
+	HeapTupleSetValue(pg_index, indimmediate, BoolGetDatum(immediate), values);
+	HeapTupleSetValue(pg_index, indisclustered, BoolGetDatum(false), values);
+	HeapTupleSetValue(pg_index, indisvalid, BoolGetDatum(isvalid), values);
+	HeapTupleSetValue(pg_index, indcheckxmin, BoolGetDatum(false), values);
+	HeapTupleSetValue(pg_index, indisready, BoolGetDatum(isready), values);
+	HeapTupleSetValue(pg_index, indislive, BoolGetDatum(true), values);
+	HeapTupleSetValue(pg_index, indisreplident, BoolGetDatum(false), values);
+	HeapTupleSetValue(pg_index, indkey, PointerGetDatum(indkey), values);
+	HeapTupleSetValue(pg_index, indcollation, PointerGetDatum(indcollation), values);
+	HeapTupleSetValue(pg_index, indclass, PointerGetDatum(indclass), values);
+	HeapTupleSetValue(pg_index, indoption, PointerGetDatum(indoption), values);
+	HeapTupleSetValue(pg_index, indexprs, exprsDatum, values);
 	if (exprsDatum == (Datum) 0)
-		nulls[Anum_pg_index_indexprs - 1] = true;
-	values[Anum_pg_index_indpred - 1] = predDatum;
+		HeapTupleSetValueNull(pg_index, indexprs, values, nulls);
+	HeapTupleSetValue(pg_index, indpred, predDatum, values);
 	if (predDatum == (Datum) 0)
-		nulls[Anum_pg_index_indpred - 1] = true;
+		HeapTupleSetValueNull(pg_index, indpred, values, nulls);
 
 	tuple = heap_form_tuple(RelationGetDescr(pg_index), values, nulls);
 
 	/*
 	 * insert the tuple into the pg_index catalog
 	 */
-	CatalogTupleInsert(pg_index, tuple);
+	CatalogTupleInsert(pg_index, tuple, NULL);
 
 	/*
 	 * close the relation and free the tuple
@@ -1567,6 +1567,8 @@ index_concurrently_swap(Oid newIndexId, Oid oldIndexId, const char *oldName)
 	Oid			indexConstraintOid;
 	List	   *constraintOids = NIL;
 	ListCell   *lc;
+	Bitmapset  *oldUpdated = NULL;
+	Bitmapset  *newUpdated = NULL;
 
 	/*
 	 * Take a necessary lock on the old and new index before swapping them.
@@ -1592,14 +1594,21 @@ index_concurrently_swap(Oid newIndexId, Oid oldIndexId, const char *oldName)
 	/* Swap the names */
 	namestrcpy(&newClassForm->relname, NameStr(oldClassForm->relname));
 	namestrcpy(&oldClassForm->relname, oldName);
+	HeapTupleUpdateField(pg_class, relname, newClassForm->relname, newClassForm, newUpdated);
+	HeapTupleUpdateField(pg_class, relname, oldClassForm->relname, oldClassForm, oldUpdated);
 
 	/* Swap the partition flags to track inheritance properly */
 	isPartition = newClassForm->relispartition;
-	newClassForm->relispartition = oldClassForm->relispartition;
-	oldClassForm->relispartition = isPartition;
+	HeapTupleUpdateField(pg_class, relispartition, oldClassForm->relispartition, newClassForm, newUpdated);
+	HeapTupleUpdateField(pg_class, relispartition, isPartition, oldClassForm, oldUpdated);
 
-	CatalogTupleUpdate(pg_class, &oldClassTuple->t_self, oldClassTuple);
-	CatalogTupleUpdate(pg_class, &newClassTuple->t_self, newClassTuple);
+	CatalogTupleUpdate(pg_class, &oldClassTuple->t_self, oldClassTuple, oldUpdated, NULL);
+	CatalogTupleUpdate(pg_class, &newClassTuple->t_self, newClassTuple, newUpdated, NULL);
+
+	bms_free(oldUpdated);
+	oldUpdated = NULL;
+	bms_free(newUpdated);
+	newUpdated = NULL;
 
 	heap_freetuple(oldClassTuple);
 	heap_freetuple(newClassTuple);
@@ -1623,34 +1632,39 @@ index_concurrently_swap(Oid newIndexId, Oid oldIndexId, const char *oldName)
 	 * Copy constraint flags from the old index. This is safe because the old
 	 * index guaranteed uniqueness.
 	 */
-	newIndexForm->indisprimary = oldIndexForm->indisprimary;
-	oldIndexForm->indisprimary = false;
-	newIndexForm->indisexclusion = oldIndexForm->indisexclusion;
-	oldIndexForm->indisexclusion = false;
-	newIndexForm->indimmediate = oldIndexForm->indimmediate;
-	oldIndexForm->indimmediate = true;
+	HeapTupleUpdateField(pg_index, indisprimary, oldIndexForm->indisprimary, newIndexForm, newUpdated);
+	HeapTupleUpdateField(pg_index, indisprimary, false, oldIndexForm, oldUpdated);
+	HeapTupleUpdateField(pg_index, indisexclusion, oldIndexForm->indisexclusion, newIndexForm, newUpdated);
+	HeapTupleUpdateField(pg_index, indisexclusion, false, oldIndexForm, oldUpdated);
+	HeapTupleUpdateField(pg_index, indimmediate, oldIndexForm->indimmediate, newIndexForm, newUpdated);
+	HeapTupleUpdateField(pg_index, indimmediate, true, oldIndexForm, oldUpdated);
 
 	/* Preserve indisreplident in the new index */
-	newIndexForm->indisreplident = oldIndexForm->indisreplident;
+	HeapTupleUpdateField(pg_index, indisreplident, oldIndexForm->indisreplident, newIndexForm, newUpdated);
 
 	/* Preserve indisclustered in the new index */
-	newIndexForm->indisclustered = oldIndexForm->indisclustered;
+	HeapTupleUpdateField(pg_index, indisclustered, oldIndexForm->indisclustered, newIndexForm, newUpdated);
 
 	/*
 	 * Mark the new index as valid, and the old index as invalid similarly to
 	 * what index_set_state_flags() does.
 	 */
-	newIndexForm->indisvalid = true;
-	oldIndexForm->indisvalid = false;
-	oldIndexForm->indisclustered = false;
-	oldIndexForm->indisreplident = false;
+	HeapTupleUpdateField(pg_index, indisvalid, true, newIndexForm, newUpdated);
+	HeapTupleUpdateField(pg_index, indisvalid, false, oldIndexForm, oldUpdated);
+	HeapTupleUpdateField(pg_index, indisclustered, false, oldIndexForm, oldUpdated);
+	HeapTupleUpdateField(pg_index, indisreplident, false, oldIndexForm, oldUpdated);
 
-	CatalogTupleUpdate(pg_index, &oldIndexTuple->t_self, oldIndexTuple);
-	CatalogTupleUpdate(pg_index, &newIndexTuple->t_self, newIndexTuple);
+	CatalogTupleUpdate(pg_index, &oldIndexTuple->t_self, oldIndexTuple, oldUpdated, NULL);
+	CatalogTupleUpdate(pg_index, &newIndexTuple->t_self, newIndexTuple, newUpdated, NULL);
 
 	heap_freetuple(oldIndexTuple);
 	heap_freetuple(newIndexTuple);
 
+	bms_free(oldUpdated);
+	oldUpdated = NULL;
+	bms_free(newUpdated);
+	newUpdated = NULL;
+
 	/*
 	 * Move constraints and triggers over to the new index
 	 */
@@ -1684,9 +1698,11 @@ index_concurrently_swap(Oid newIndexId, Oid oldIndexId, const char *oldName)
 
 		if (conForm->conindid == oldIndexId)
 		{
-			conForm->conindid = newIndexId;
+			Bitmapset  *updated = NULL;
 
-			CatalogTupleUpdate(pg_constraint, &constraintTuple->t_self, constraintTuple);
+			HeapTupleUpdateField(pg_constraint, conindid, newIndexId, conForm, updated);
+			CatalogTupleUpdate(pg_constraint, &constraintTuple->t_self, constraintTuple, updated, NULL);
+			bms_free(updated);
 		}
 
 		heap_freetuple(constraintTuple);
@@ -1702,6 +1718,8 @@ index_concurrently_swap(Oid newIndexId, Oid oldIndexId, const char *oldName)
 
 		while (HeapTupleIsValid((triggerTuple = systable_getnext(scan))))
 		{
+			Bitmapset  *updated = NULL;
+
 			Form_pg_trigger tgForm = (Form_pg_trigger) GETSTRUCT(triggerTuple);
 
 			if (tgForm->tgconstrindid != oldIndexId)
@@ -1711,10 +1729,9 @@ index_concurrently_swap(Oid newIndexId, Oid oldIndexId, const char *oldName)
 			triggerTuple = heap_copytuple(triggerTuple);
 			tgForm = (Form_pg_trigger) GETSTRUCT(triggerTuple);
 
-			tgForm->tgconstrindid = newIndexId;
-
-			CatalogTupleUpdate(pg_trigger, &triggerTuple->t_self, triggerTuple);
-
+			HeapTupleUpdateField(pg_trigger, tgconstrindid, newIndexId, tgForm, updated);
+			CatalogTupleUpdate(pg_trigger, &triggerTuple->t_self, triggerTuple, updated, NULL);
+			bms_free(updated);
 			heap_freetuple(triggerTuple);
 		}
 
@@ -1730,11 +1747,10 @@ index_concurrently_swap(Oid newIndexId, Oid oldIndexId, const char *oldName)
 		SysScanDesc sd;
 		HeapTuple	tuple;
 		Datum		values[Natts_pg_description] = {0};
-		bool		nulls[Natts_pg_description] = {0};
-		bool		replaces[Natts_pg_description] = {0};
+		bool		nulls[Natts_pg_description] = {false};
+		Bitmapset  *updated = NULL;
 
-		values[Anum_pg_description_objoid - 1] = ObjectIdGetDatum(newIndexId);
-		replaces[Anum_pg_description_objoid - 1] = true;
+		HeapTupleUpdateValue(pg_description, objoid, ObjectIdGetDatum(newIndexId), values, nulls, updated);
 
 		ScanKeyInit(&skey[0],
 					Anum_pg_description_objoid,
@@ -1756,15 +1772,16 @@ index_concurrently_swap(Oid newIndexId, Oid oldIndexId, const char *oldName)
 
 		while ((tuple = systable_getnext(sd)) != NULL)
 		{
-			tuple = heap_modify_tuple(tuple, RelationGetDescr(description),
-									  values, nulls, replaces);
-			CatalogTupleUpdate(description, &tuple->t_self, tuple);
+			tuple = heap_update_tuple(tuple, RelationGetDescr(description),
+									  values, nulls, updated);
+			CatalogTupleUpdate(description, &tuple->t_self, tuple, updated, NULL);
 
 			break;				/* Assume there can be only one match */
 		}
 
 		systable_endscan(sd);
 		table_close(description, NoLock);
+		bms_free(updated);
 	}
 
 	/*
@@ -2059,6 +2076,7 @@ index_constraint_create(Relation heapRelation,
 		Form_pg_index indexForm;
 		bool		dirty = false;
 		bool		marked_as_primary = false;
+		Bitmapset  *updated = NULL;
 
 		pg_index = table_open(IndexRelationId, RowExclusiveLock);
 
@@ -2070,20 +2088,20 @@ index_constraint_create(Relation heapRelation,
 
 		if (mark_as_primary && !indexForm->indisprimary)
 		{
-			indexForm->indisprimary = true;
+			HeapTupleUpdateField(pg_index, indisprimary, true, indexForm, updated);
 			dirty = true;
 			marked_as_primary = true;
 		}
 
 		if (deferrable && indexForm->indimmediate)
 		{
-			indexForm->indimmediate = false;
+			HeapTupleUpdateField(pg_index, indimmediate, false, indexForm, updated);
 			dirty = true;
 		}
 
 		if (dirty)
 		{
-			CatalogTupleUpdate(pg_index, &indexTuple->t_self, indexTuple);
+			CatalogTupleUpdate(pg_index, &indexTuple->t_self, indexTuple, updated, NULL);
 
 			/*
 			 * When we mark an existing index as primary, force a relcache
@@ -2100,6 +2118,7 @@ index_constraint_create(Relation heapRelation,
 
 		heap_freetuple(indexTuple);
 		table_close(pg_index, RowExclusiveLock);
+		bms_free(updated);
 	}
 
 	return myself;
@@ -3128,6 +3147,7 @@ index_build(Relation heapRelation,
 		Relation	pg_index;
 		HeapTuple	indexTuple;
 		Form_pg_index indexForm;
+		Bitmapset  *updated = NULL;
 
 		pg_index = table_open(IndexRelationId, RowExclusiveLock);
 
@@ -3140,11 +3160,12 @@ index_build(Relation heapRelation,
 		/* If it's a new index, indcheckxmin shouldn't be set ... */
 		Assert(!indexForm->indcheckxmin);
 
-		indexForm->indcheckxmin = true;
-		CatalogTupleUpdate(pg_index, &indexTuple->t_self, indexTuple);
+		HeapTupleUpdateField(pg_index, indcheckxmin, true, indexForm, updated);
+		CatalogTupleUpdate(pg_index, &indexTuple->t_self, indexTuple, updated, NULL);
 
 		heap_freetuple(indexTuple);
 		table_close(pg_index, RowExclusiveLock);
+		bms_free(updated);
 	}
 
 	/*
@@ -3503,6 +3524,7 @@ index_set_state_flags(Oid indexId, IndexStateFlagsAction action)
 	Relation	pg_index;
 	HeapTuple	indexTuple;
 	Form_pg_index indexForm;
+	Bitmapset  *updated = NULL;
 
 	/* Open pg_index and fetch a writable copy of the index's tuple */
 	pg_index = table_open(IndexRelationId, RowExclusiveLock);
@@ -3521,14 +3543,14 @@ index_set_state_flags(Oid indexId, IndexStateFlagsAction action)
 			Assert(indexForm->indislive);
 			Assert(!indexForm->indisready);
 			Assert(!indexForm->indisvalid);
-			indexForm->indisready = true;
+			HeapTupleUpdateField(pg_index, indisready, true, indexForm, updated);
 			break;
 		case INDEX_CREATE_SET_VALID:
 			/* Set indisvalid during a CREATE INDEX CONCURRENTLY sequence */
 			Assert(indexForm->indislive);
 			Assert(indexForm->indisready);
 			Assert(!indexForm->indisvalid);
-			indexForm->indisvalid = true;
+			HeapTupleUpdateField(pg_index, indisvalid, true, indexForm, updated);
 			break;
 		case INDEX_DROP_CLEAR_VALID:
 
@@ -3545,9 +3567,9 @@ index_set_state_flags(Oid indexId, IndexStateFlagsAction action)
 			 * set on any invalid index, so clear that flag too.  For
 			 * cleanliness, also clear indisreplident.
 			 */
-			indexForm->indisvalid = false;
-			indexForm->indisclustered = false;
-			indexForm->indisreplident = false;
+			HeapTupleUpdateField(pg_index, indisvalid, false, indexForm, updated);
+			HeapTupleUpdateField(pg_index, indisclustered, false, indexForm, updated);
+			HeapTupleUpdateField(pg_index, indisreplident, false, indexForm, updated);
 			break;
 		case INDEX_DROP_SET_DEAD:
 
@@ -3561,15 +3583,16 @@ index_set_state_flags(Oid indexId, IndexStateFlagsAction action)
 			Assert(!indexForm->indisvalid);
 			Assert(!indexForm->indisclustered);
 			Assert(!indexForm->indisreplident);
-			indexForm->indisready = false;
-			indexForm->indislive = false;
+			HeapTupleUpdateField(pg_index, indisready, false, indexForm, updated);
+			HeapTupleUpdateField(pg_index, indislive, false, indexForm, updated);
 			break;
 	}
 
 	/* ... and update it */
-	CatalogTupleUpdate(pg_index, &indexTuple->t_self, indexTuple);
+	CatalogTupleUpdate(pg_index, &indexTuple->t_self, indexTuple, updated, NULL);
 
 	table_close(pg_index, RowExclusiveLock);
+	bms_free(updated);
 }
 
 
@@ -3848,6 +3871,7 @@ reindex_index(const ReindexStmt *stmt, Oid indexId,
 		HeapTuple	indexTuple;
 		Form_pg_index indexForm;
 		bool		index_bad;
+		Bitmapset  *updated = NULL;
 
 		pg_index = table_open(IndexRelationId, RowExclusiveLock);
 
@@ -3864,13 +3888,13 @@ reindex_index(const ReindexStmt *stmt, Oid indexId,
 			(indexForm->indcheckxmin && !indexInfo->ii_BrokenHotChain))
 		{
 			if (!indexInfo->ii_BrokenHotChain)
-				indexForm->indcheckxmin = false;
+				HeapTupleUpdateField(pg_index, indcheckxmin, false, indexForm, updated);
 			else if (index_bad)
-				indexForm->indcheckxmin = true;
-			indexForm->indisvalid = true;
-			indexForm->indisready = true;
-			indexForm->indislive = true;
-			CatalogTupleUpdate(pg_index, &indexTuple->t_self, indexTuple);
+				HeapTupleUpdateField(pg_index, indcheckxmin, true, indexForm, updated);
+			HeapTupleUpdateField(pg_index, indisvalid, true, indexForm, updated);
+			HeapTupleUpdateField(pg_index, indisready, true, indexForm, updated);
+			HeapTupleUpdateField(pg_index, indislive, true, indexForm, updated);
+			CatalogTupleUpdate(pg_index, &indexTuple->t_self, indexTuple, updated, NULL);
 
 			/*
 			 * Invalidate the relcache for the table, so that after we commit
@@ -3883,6 +3907,7 @@ reindex_index(const ReindexStmt *stmt, Oid indexId,
 		}
 
 		table_close(pg_index, RowExclusiveLock);
+		bms_free(updated);
 	}
 
 	/* Log what we did */
diff --git a/src/backend/catalog/partition.c b/src/backend/catalog/partition.c
index 28f3cade6ff..3e6cc90af9e 100644
--- a/src/backend/catalog/partition.c
+++ b/src/backend/catalog/partition.c
@@ -342,6 +342,7 @@ update_default_partition_oid(Oid parentId, Oid defaultPartId)
 	HeapTuple	tuple;
 	Relation	pg_partitioned_table;
 	Form_pg_partitioned_table part_table_form;
+	Bitmapset  *updated = NULL;
 
 	pg_partitioned_table = table_open(PartitionedRelationId, RowExclusiveLock);
 
@@ -353,10 +354,12 @@ update_default_partition_oid(Oid parentId, Oid defaultPartId)
 
 	part_table_form = (Form_pg_partitioned_table) GETSTRUCT(tuple);
 	part_table_form->partdefid = defaultPartId;
-	CatalogTupleUpdate(pg_partitioned_table, &tuple->t_self, tuple);
+	HeapTupleMarkColumnUpdated(pg_partitioned_table, partdefid, updated);
+	CatalogTupleUpdate(pg_partitioned_table, &tuple->t_self, tuple, updated, NULL);
 
 	heap_freetuple(tuple);
 	table_close(pg_partitioned_table, RowExclusiveLock);
+	bms_free(updated);
 }
 
 /*
diff --git a/src/backend/catalog/pg_attrdef.c b/src/backend/catalog/pg_attrdef.c
index 24815090d3d..8232ddd188c 100644
--- a/src/backend/catalog/pg_attrdef.c
+++ b/src/backend/catalog/pg_attrdef.c
@@ -40,14 +40,12 @@ StoreAttrDefault(Relation rel, AttrNumber attnum,
 	char	   *adbin;
 	Relation	adrel;
 	HeapTuple	tuple;
-	Datum		values[Natts_pg_attrdef];
-	static bool nulls[Natts_pg_attrdef] = {false, false, false, false};
+	Datum		values[Natts_pg_attrdef] = {0};
+	bool		nulls[Natts_pg_attrdef] = {false};
 	Relation	attrrel;
 	HeapTuple	atttup;
 	Form_pg_attribute attStruct;
-	Datum		valuesAtt[Natts_pg_attribute] = {0};
-	bool		nullsAtt[Natts_pg_attribute] = {0};
-	bool		replacesAtt[Natts_pg_attribute] = {0};
+	Bitmapset  *updated = NULL;
 	char		attgenerated;
 	Oid			attrdefOid;
 	ObjectAddress colobject,
@@ -65,13 +63,13 @@ StoreAttrDefault(Relation rel, AttrNumber attnum,
 	 */
 	attrdefOid = GetNewOidWithIndex(adrel, AttrDefaultOidIndexId,
 									Anum_pg_attrdef_oid);
-	values[Anum_pg_attrdef_oid - 1] = ObjectIdGetDatum(attrdefOid);
-	values[Anum_pg_attrdef_adrelid - 1] = ObjectIdGetDatum(RelationGetRelid(rel));
-	values[Anum_pg_attrdef_adnum - 1] = Int16GetDatum(attnum);
-	values[Anum_pg_attrdef_adbin - 1] = CStringGetTextDatum(adbin);
+	HeapTupleSetValue(pg_attrdef, oid, ObjectIdGetDatum(attrdefOid), values);
+	HeapTupleSetValue(pg_attrdef, adrelid, ObjectIdGetDatum(RelationGetRelid(rel)), values);
+	HeapTupleSetValue(pg_attrdef, adnum, Int16GetDatum(attnum), values);
+	HeapTupleSetValue(pg_attrdef, adbin, CStringGetTextDatum(adbin), values);
 
 	tuple = heap_form_tuple(adrel->rd_att, values, nulls);
-	CatalogTupleInsert(adrel, tuple);
+	CatalogTupleInsert(adrel, tuple, NULL);
 
 	defobject.classId = AttrDefaultRelationId;
 	defobject.objectId = attrdefOid;
@@ -80,7 +78,7 @@ StoreAttrDefault(Relation rel, AttrNumber attnum,
 	table_close(adrel, RowExclusiveLock);
 
 	/* now can free some of the stuff allocated above */
-	pfree(DatumGetPointer(values[Anum_pg_attrdef_adbin - 1]));
+	pfree(DatumGetPointer(HeapTupleValue(pg_attrdef, adbin, values)));
 	heap_freetuple(tuple);
 	pfree(adbin);
 
@@ -92,22 +90,21 @@ StoreAttrDefault(Relation rel, AttrNumber attnum,
 	atttup = SearchSysCacheCopy2(ATTNUM,
 								 ObjectIdGetDatum(RelationGetRelid(rel)),
 								 Int16GetDatum(attnum));
+
 	if (!HeapTupleIsValid(atttup))
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
 			 attnum, RelationGetRelid(rel));
+
 	attStruct = (Form_pg_attribute) GETSTRUCT(atttup);
 	attgenerated = attStruct->attgenerated;
 
-	valuesAtt[Anum_pg_attribute_atthasdef - 1] = BoolGetDatum(true);
-	replacesAtt[Anum_pg_attribute_atthasdef - 1] = true;
-
-	atttup = heap_modify_tuple(atttup, RelationGetDescr(attrrel),
-							   valuesAtt, nullsAtt, replacesAtt);
-
-	CatalogTupleUpdate(attrrel, &atttup->t_self, atttup);
+	Assert(bms_is_empty(updated));
+	HeapTupleUpdateField(pg_attribute, atthasdef, BoolGetDatum(true), attStruct, updated);
+	CatalogTupleUpdate(attrrel, &atttup->t_self, atttup, updated, NULL);
 
 	table_close(attrrel, RowExclusiveLock);
 	heap_freetuple(atttup);
+	bms_free(updated);
 
 	/*
 	 * Make a dependency so that the pg_attrdef entry goes away if the column
@@ -216,6 +213,7 @@ RemoveAttrDefaultById(Oid attrdefId)
 	HeapTuple	tuple;
 	Oid			myrelid;
 	AttrNumber	myattnum;
+	Bitmapset  *updated = NULL;
 
 	/* Grab an appropriate lock on the pg_attrdef relation */
 	attrdef_rel = table_open(AttrDefaultRelationId, RowExclusiveLock);
@@ -256,8 +254,8 @@ RemoveAttrDefaultById(Oid attrdefId)
 			 myattnum, myrelid);
 
 	((Form_pg_attribute) GETSTRUCT(tuple))->atthasdef = false;
-
-	CatalogTupleUpdate(attr_rel, &tuple->t_self, tuple);
+	HeapTupleMarkColumnUpdated(pg_attribute, atthasdef, updated);
+	CatalogTupleUpdate(attr_rel, &tuple->t_self, tuple, updated, NULL);
 
 	/*
 	 * Our update of the pg_attribute row will force a relcache rebuild, so
diff --git a/src/backend/catalog/pg_cast.c b/src/backend/catalog/pg_cast.c
index 5119c2acda2..f472f9cb354 100644
--- a/src/backend/catalog/pg_cast.c
+++ b/src/backend/catalog/pg_cast.c
@@ -53,8 +53,8 @@ CastCreate(Oid sourcetypeid, Oid targettypeid,
 	Relation	relation;
 	HeapTuple	tuple;
 	Oid			castid;
-	Datum		values[Natts_pg_cast];
-	bool		nulls[Natts_pg_cast] = {0};
+	Datum		values[Natts_pg_cast] = {0};
+	bool		nulls[Natts_pg_cast] = {false};
 	ObjectAddress myself,
 				referenced;
 	ObjectAddresses *addrs;
@@ -78,16 +78,16 @@ CastCreate(Oid sourcetypeid, Oid targettypeid,
 
 	/* ready to go */
 	castid = GetNewOidWithIndex(relation, CastOidIndexId, Anum_pg_cast_oid);
-	values[Anum_pg_cast_oid - 1] = ObjectIdGetDatum(castid);
-	values[Anum_pg_cast_castsource - 1] = ObjectIdGetDatum(sourcetypeid);
-	values[Anum_pg_cast_casttarget - 1] = ObjectIdGetDatum(targettypeid);
-	values[Anum_pg_cast_castfunc - 1] = ObjectIdGetDatum(funcid);
-	values[Anum_pg_cast_castcontext - 1] = CharGetDatum(castcontext);
-	values[Anum_pg_cast_castmethod - 1] = CharGetDatum(castmethod);
+	HeapTupleSetValue(pg_cast, oid, ObjectIdGetDatum(castid), values);
+	HeapTupleSetValue(pg_cast, castsource, ObjectIdGetDatum(sourcetypeid), values);
+	HeapTupleSetValue(pg_cast, casttarget, ObjectIdGetDatum(targettypeid), values);
+	HeapTupleSetValue(pg_cast, castfunc, ObjectIdGetDatum(funcid), values);
+	HeapTupleSetValue(pg_cast, castcontext, CharGetDatum(castcontext), values);
+	HeapTupleSetValue(pg_cast, castmethod, CharGetDatum(castmethod), values);
 
 	tuple = heap_form_tuple(RelationGetDescr(relation), values, nulls);
 
-	CatalogTupleInsert(relation, tuple);
+	CatalogTupleInsert(relation, tuple, NULL);
 
 	addrs = new_object_addresses();
 
diff --git a/src/backend/catalog/pg_collation.c b/src/backend/catalog/pg_collation.c
index 26d42c3e51a..33228ee7442 100644
--- a/src/backend/catalog/pg_collation.c
+++ b/src/backend/catalog/pg_collation.c
@@ -54,8 +54,8 @@ CollationCreate(const char *collname, Oid collnamespace,
 	Relation	rel;
 	TupleDesc	tupDesc;
 	HeapTuple	tup;
-	Datum		values[Natts_pg_collation];
-	bool		nulls[Natts_pg_collation];
+	Datum		values[Natts_pg_collation] = {0};
+	bool		nulls[Natts_pg_collation] = {false};
 	NameData	name_name;
 	Oid			oid;
 	ObjectAddress myself,
@@ -175,38 +175,38 @@ CollationCreate(const char *collname, Oid collnamespace,
 	namestrcpy(&name_name, collname);
 	oid = GetNewOidWithIndex(rel, CollationOidIndexId,
 							 Anum_pg_collation_oid);
-	values[Anum_pg_collation_oid - 1] = ObjectIdGetDatum(oid);
-	values[Anum_pg_collation_collname - 1] = NameGetDatum(&name_name);
-	values[Anum_pg_collation_collnamespace - 1] = ObjectIdGetDatum(collnamespace);
-	values[Anum_pg_collation_collowner - 1] = ObjectIdGetDatum(collowner);
-	values[Anum_pg_collation_collprovider - 1] = CharGetDatum(collprovider);
-	values[Anum_pg_collation_collisdeterministic - 1] = BoolGetDatum(collisdeterministic);
-	values[Anum_pg_collation_collencoding - 1] = Int32GetDatum(collencoding);
+	HeapTupleSetValue(pg_collation, oid, ObjectIdGetDatum(oid), values);
+	HeapTupleSetValue(pg_collation, collname, NameGetDatum(&name_name), values);
+	HeapTupleSetValue(pg_collation, collnamespace, ObjectIdGetDatum(collnamespace), values);
+	HeapTupleSetValue(pg_collation, collowner, ObjectIdGetDatum(collowner), values);
+	HeapTupleSetValue(pg_collation, collprovider, CharGetDatum(collprovider), values);
+	HeapTupleSetValue(pg_collation, collisdeterministic, BoolGetDatum(collisdeterministic), values);
+	HeapTupleSetValue(pg_collation, collencoding, Int32GetDatum(collencoding), values);
 	if (collcollate)
-		values[Anum_pg_collation_collcollate - 1] = CStringGetTextDatum(collcollate);
+		HeapTupleSetValue(pg_collation, collcollate, CStringGetTextDatum(collcollate), values);
 	else
-		nulls[Anum_pg_collation_collcollate - 1] = true;
+		HeapTupleSetValueNull(pg_collation, collcollate, values, nulls);
 	if (collctype)
-		values[Anum_pg_collation_collctype - 1] = CStringGetTextDatum(collctype);
+		HeapTupleSetValue(pg_collation, collctype, CStringGetTextDatum(collctype), values);
 	else
-		nulls[Anum_pg_collation_collctype - 1] = true;
+		HeapTupleSetValueNull(pg_collation, collctype, values, nulls);
 	if (colllocale)
-		values[Anum_pg_collation_colllocale - 1] = CStringGetTextDatum(colllocale);
+		HeapTupleSetValue(pg_collation, colllocale, CStringGetTextDatum(colllocale), values);
 	else
-		nulls[Anum_pg_collation_colllocale - 1] = true;
+		HeapTupleSetValueNull(pg_collation, colllocale, values, nulls);
 	if (collicurules)
-		values[Anum_pg_collation_collicurules - 1] = CStringGetTextDatum(collicurules);
+		HeapTupleSetValue(pg_collation, collicurules, CStringGetTextDatum(collicurules), values);
 	else
-		nulls[Anum_pg_collation_collicurules - 1] = true;
+		HeapTupleSetValueNull(pg_collation, collicurules, values, nulls);
 	if (collversion)
-		values[Anum_pg_collation_collversion - 1] = CStringGetTextDatum(collversion);
+		HeapTupleSetValue(pg_collation, collversion, CStringGetTextDatum(collversion), values);
 	else
-		nulls[Anum_pg_collation_collversion - 1] = true;
+		HeapTupleSetValueNull(pg_collation, collversion, values, nulls);
 
 	tup = heap_form_tuple(tupDesc, values, nulls);
 
 	/* insert a new tuple */
-	CatalogTupleInsert(rel, tup);
+	CatalogTupleInsert(rel, tup, NULL);
 	Assert(OidIsValid(oid));
 
 	/* set up dependencies for the new collation */
diff --git a/src/backend/catalog/pg_conversion.c b/src/backend/catalog/pg_conversion.c
index 0accc83cb1e..a0147dfddc0 100644
--- a/src/backend/catalog/pg_conversion.c
+++ b/src/backend/catalog/pg_conversion.c
@@ -45,8 +45,8 @@ ConversionCreate(const char *conname, Oid connamespace,
 	TupleDesc	tupDesc;
 	HeapTuple	tup;
 	Oid			oid;
-	bool		nulls[Natts_pg_conversion];
-	Datum		values[Natts_pg_conversion];
+	Datum		values[Natts_pg_conversion] = {0};
+	bool		nulls[Natts_pg_conversion] = {false};
 	NameData	cname;
 	ObjectAddress myself,
 				referenced;
@@ -94,19 +94,19 @@ ConversionCreate(const char *conname, Oid connamespace,
 	namestrcpy(&cname, conname);
 	oid = GetNewOidWithIndex(rel, ConversionOidIndexId,
 							 Anum_pg_conversion_oid);
-	values[Anum_pg_conversion_oid - 1] = ObjectIdGetDatum(oid);
-	values[Anum_pg_conversion_conname - 1] = NameGetDatum(&cname);
-	values[Anum_pg_conversion_connamespace - 1] = ObjectIdGetDatum(connamespace);
-	values[Anum_pg_conversion_conowner - 1] = ObjectIdGetDatum(conowner);
-	values[Anum_pg_conversion_conforencoding - 1] = Int32GetDatum(conforencoding);
-	values[Anum_pg_conversion_contoencoding - 1] = Int32GetDatum(contoencoding);
-	values[Anum_pg_conversion_conproc - 1] = ObjectIdGetDatum(conproc);
-	values[Anum_pg_conversion_condefault - 1] = BoolGetDatum(def);
+	HeapTupleSetValue(pg_conversion, oid, ObjectIdGetDatum(oid), values);
+	HeapTupleSetValue(pg_conversion, conname, NameGetDatum(&cname), values);
+	HeapTupleSetValue(pg_conversion, connamespace, ObjectIdGetDatum(connamespace), values);
+	HeapTupleSetValue(pg_conversion, conowner, ObjectIdGetDatum(conowner), values);
+	HeapTupleSetValue(pg_conversion, conforencoding, Int32GetDatum(conforencoding), values);
+	HeapTupleSetValue(pg_conversion, contoencoding, Int32GetDatum(contoencoding), values);
+	HeapTupleSetValue(pg_conversion, conproc, ObjectIdGetDatum(conproc), values);
+	HeapTupleSetValue(pg_conversion, condefault, BoolGetDatum(def), values);
 
 	tup = heap_form_tuple(tupDesc, values, nulls);
 
 	/* insert a new tuple */
-	CatalogTupleInsert(rel, tup);
+	CatalogTupleInsert(rel, tup, NULL);
 
 	myself.classId = ConversionRelationId;
 	myself.objectId = oid;
